--[[
WarlockReminder Continued Beta v1.20
06 Dec 2010
Author: CKlausi/Biny of Anetheron EU
Original Author of WarlockReminder: Vux of Dragonblight-US
Description: Reminds you of important Warlock-Buffs + Combatreminders
File: WarlockReminderFrame.lua
]]--

local WarlockReminder = LibStub("AceAddon-3.0"):GetAddon("WarlockReminder")
local L = LibStub("AceLocale-3.0"):GetLocale("WarlockReminder")

local diWidth = 132
local diHeight = 36

function WarlockReminder:CreateFrames()
	-- Set up anchor
	wlranchor = CreateFrame("Frame", nil, UIParent), {}
	wlranchor:SetWidth(100)
	wlranchor:SetHeight(24)
	wlranchor:SetBackdrop({ bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 8, edgeSize = 12, insets = { left = 2, right = 2, top = 2, bottom = 2 } })
	wlranchor:SetBackdropColor(0.1,0.1,0.2,1)
	wlranchor:SetBackdropBorderColor(0.1,0.1,0.1,1)
	wlranchor:SetMovable(1)
	wlranchor:EnableMouse(1)
	wlranchor:SetToplevel(1)
	wlranchor:SetClampedToScreen(1)
	wlranchor:SetPoint("CENTER")
	wlranchor:Hide()

	wlranchor.text = wlranchor:CreateFontString(nil,"ARTWORK","GameFontHighlight")
	wlranchor.text:SetText("wlranchor")
	wlranchor.text:SetPoint("LEFT",6,0)

	wlranchor.close = CreateFrame("Button",nil,wlranchor,"UIPanelCloseButton")
	wlranchor.close:SetWidth(24)
	wlranchor.close:SetHeight(24)
	wlranchor.close:SetPoint("RIGHT")
	-- END Set up anchor

	-- Set up frame
	wlrframe = CreateFrame("Frame", nil, UIParent), {}
	wlrtexture = wlrframe:CreateTexture()
	wlrframe:SetAlpha(1)
	wlrframe:SetPoint("CENTER",wlranchor,0,-42)
	wlrframe:SetWidth(48)
	wlrframe:SetHeight(48)
	wlrtexture:SetAllPoints(wlrframe)
	wlrframe.text = wlrframe:CreateFontString(nil,"OVERLAY","GameFontHighlight")
	wlrframe.text:SetFont("Fonts\\FRIZQT__.TTF", 20, "OUTLINE")
	wlrframe:Hide()
	-- END Set up frame

	-- Set up diFrame
	diFrame = CreateFrame("Button", nil, UIParent, "SecureActionButtonTemplate"), {}
	diFrame:RegisterForClicks("LeftButtonDown")
	diFrame:SetAttribute("type", "spell")
	diFrame:SetAttribute("unit", "target")
	diFrame:SetAttribute("spell", DarkIntentSpell)

	diFrame:SetAlpha(1)
	diFrame:SetPoint("CENTER", UIParent, 0, 40)
	diFrame:SetWidth(diWidth)
	diFrame:SetHeight(diHeight)

	diFrame:SetBackdrop({ bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 8, edgeSize = 12, insets = { left = 2, right = 2, top = 2, bottom = 2 } })
	diFrame:SetBackdropColor(0.1,0.1,0.2,1)
	diFrame:SetBackdropBorderColor(0.1,0.1,0.1,1)
	diFrame:SetMovable(1)
	--diFrame:EnableMouse(1)
	diFrame:SetToplevel(1)
	diFrame:SetClampedToScreen(1)

	--Set up diTextureFrame
	diTextureFrame = CreateFrame("Frame", nil, diFrame), {}
	diTextureFrame:SetAlpha(0.75)
	diTextureFrame:SetPoint("LEFT", diFrame, 2, 0)
	diTextureFrame:SetWidth(32)
	diTextureFrame:SetHeight(32)
	diTexture = diTextureFrame:CreateTexture()
	diTexture:SetTexture(GetSpellTexture(DarkIntent))
	diTexture:SetAllPoints(diTextureFrame)
	diTextureFrame:Show()

	-- Set up diFontFrame
	diFontFrame = CreateFrame("Frame", nil, diFrame), {}
	diFontFrame:SetAlpha(0.75)
	diFontFrame:SetPoint("LEFT", diFrame, diTextureFrame:GetWidth(), 0)
	diFontFrame:SetWidth(diWidth-32)
	diFontFrame:SetHeight(diHeight -4)

	diFontFrame.text = diFontFrame:CreateFontString(nil,"ARTWORK","GameFontHighlight")
	diFontFrame.text:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE")
	diFontFrame.text:SetText(L["No Dark Intent"])
	diFontFrame.text:SetPoint("LEFT",5,6)

	diFontFrame.textTime = diFontFrame:CreateFontString(nil,"ARTWORK","GameFontHighlight")
	diFontFrame.textTime:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE")
	diFontFrame.textTime:SetText("")
	diFontFrame.textTime:SetPoint("LEFT",5,-6)

	diFrame:Show()
	--END Set up diFrame
	
	-- Move anchor
	wlranchor:SetScript("OnMouseDown",wlranchor.StartMoving)
	wlranchor:SetScript("OnMouseUp",
		function(self) 
			self:StopMovingOrSizing() 
			-- Set anchor
			WarlockReminder:SetWlrAnchorLeft("Anchor", self:GetLeft()) 
			WarlockReminder:SetWlrAnchorTop("Anchor", self:GetTop()) 
			WarlockReminder:FramesToAnchor()
		end
	)
	wlranchor:SetScript("OnEvent",function(self,event,...) self[event](self,event,...) end)
	-- END Move anchor

	-- Move Dark Intent
	diFrame:SetScript("OnMouseDown", 
		function(self)
			if self:IsMovable() == 1 then
				self:StartMoving()
			end
		end
	)
	diFrame:SetScript("OnMouseUp",
		function(self) 
			if self:IsMovable() == 1 then
				self:StopMovingOrSizing() 
				-- Set diFrame
				WarlockReminder:SetDiFrameLeft("diFrame", self:GetLeft()) 
				WarlockReminder:SetDiFrameTop("diFrame", self:GetTop()) 
			end
		end
	)
	diFrame:SetScript("OnEvent",function(self,event,...) self[event](self,event,...) end)
	-- END Move Dark Intent
end
-- END CreateFrames

-- Resets the anchor to the middle of the screen
function WarlockReminder:ResetAnchor()
	wlranchor:ClearAllPoints()
	wlranchor:SetPoint("CENTER",UIParent,"CENTER", 0, 0)
	self:SetWlrAnchorLeft("Anchor", wlranchor:GetLeft())
	self:SetWlrAnchorTop("Anchor", wlranchor:GetTop())
	WarlockReminder:FramesToAnchor()
	wlranchor:Show()
end

-- Resets the diFrame to the middle of the screen
function WarlockReminder:ResetDiFrame()
	diFrame:ClearAllPoints()
	diFrame:SetPoint("CENTER",UIParent,"CENTER", 0, 40)
	self:SetDiFrameLeft("diFrame", diFrame:GetLeft())
	self:SetDiFrameTop("diFrame", diFrame:GetTop())
	diFrame:Show()
end

function WarlockReminder:DiFrameSetFontGab()
	diFontFrame.text:SetPoint("LEFT",5,4+(0.2*diFontFrame.text:GetHeight()))
	diFontFrame.textTime:SetPoint("LEFT",5,-4-(0.2*diFontFrame.textTime:GetHeight()))
end

function WarlockReminder:DiFrameSetup()
	diFrame:ClearAllPoints()
	-- Position
	diFrame:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT", self.db.profile.diFrameLeft, self.db.profile.diFrameTop)
	
	-- Alpha
	diFrame:SetAlpha(self.db.profile.diFrameAlpha)
	-- BG Alpha
	diFrame:SetBackdropColor(0.1,0.1,0.2,self.db.profile.diBgAlpha)
	diFrame:SetBackdropBorderColor(0.1,0.1,0.1,self.db.profile.diBgAlpha)
	
	-- Size
	diFrame:SetWidth((diWidth*self.db.profile.diFrameSize)+self.db.profile.diExtraWidth)
	diFrame:SetHeight(diHeight*self.db.profile.diFrameSize)
	diTextureFrame:SetWidth((diHeight-4)*self.db.profile.diFrameSize)
	diTextureFrame:SetHeight((diHeight-4)*self.db.profile.diFrameSize)
	diTexture:SetAllPoints(diTextureFrame)
	
	-- Font
	diFontFrame:SetWidth((diWidth-32)*self.db.profile.diFrameSize)
	diFontFrame:SetHeight((diHeight-4)*self.db.profile.diFrameSize)
	diFontFrame:SetPoint("LEFT", diFrame, diTextureFrame:GetWidth(), 0)
	diFontFrame.textTime:SetFont("Fonts\\FRIZQT__.TTF", self.db.profile.diFontSize, "OUTLINE")
	diFontFrame.text:SetFont("Fonts\\FRIZQT__.TTF", self.db.profile.diFontSize, "OUTLINE")
	self:DiFrameSetFontGab()
	
	-- Movable
	if(self.db.profile.diFrameLock == true) then 
		diFrame:SetMovable(0)
	else 
		diFrame:SetMovable(1) 
	end
	
	if(self.db.profile.showDarkIntentFrame) then diFrame:Show()
	else diFrame:Hide() end
end

-- Attach all frames to the anchor
function WarlockReminder:FramesToAnchor()
	wlrframe:SetPoint("CENTER",wlranchor,0,-42) 
end

-- Show the reminder frame
function WarlockReminder:WlrFrame(show, texture)
	if texture then wlrtexture:SetTexture(GetSpellTexture(texture))
	else wlrtexture:SetTexture(GetSpellTexture(DrainSoul)) end
	if show then 
		wlrframe.text:SetText("")
		wlrframe:Show()
	else 
		wlrframe:Hide()
	end
end

-- Show the drain soul frame
function WarlockReminder:WlrDrainSoulFrame(show)
	if show then 
		wlrtexture:SetTexture(GetSpellTexture(DrainSoul))
		wlrframe.text:SetText("")
		wlrframe:Show()
		self:CancelTimer(self.drainsoultimer, true)
		if self:GetDrainSoulDuration("DrainSoulFrame") > 0 then
			self.drainsoultimer = self:ScheduleTimer("WlrDrainSoulFrame", self.db.profile.drainSoulDuration, false)
		end
	else 
		self:CancelTimer(self.drainsoultimer, true)
		wlrframe:Hide() 
	end
end

-- Show the Molten Core Frame
function WarlockReminder:WlrMoltenCoreFrame(show, count)
	if not count then count = 0 end
	if show then
		wlrtexture:SetTexture(GetSpellTexture(MoltenCore3))
		wlrframe.text:SetText(tostring(count))
		wlrframe.text:SetPoint("BOTTOMRIGHT",-3,3)
		wlrframe:Show()
	else
		wlrframe:Hide()
	end
end
